<?php
/*
Category View
Version 2.0
by: SoLoGHoST
http://graphicsmayhem.com
Copyright 2009 Solomon Closson

Category.php
############################################
License Information:
Author Credits above must remain intact.
#############################################
Additional Notes:  Compatibility only with SMF 2.0.x!!
#############################################
*/

if (!defined('SMF'))
	die('Hacking attempt...');

function Category()
{
	global $currentVersion;

	$currentVersion = '2.0.0';
	// Load the language files
	if (loadlanguage('Category') == false)
		loadLanguage('Category','english');

	// Load the main template file
	loadtemplate('Category');
	// Define the sub actions array
	$subActions = array(
		'main' => 'CategoryView',
		'layout' => 'SetLayout',
	);
	// Follow the sa or just go to  the main function
	if (isset($_GET['sa']))
		$sa = $_GET['sa'];
	else
		$sa = 'CategoryView';

	if (!empty($subActions[$sa]))
		$subActions[$sa]();
	else
		CategoryView();
}

function CategoryView()
{
	global $context, $scripturl, $txt, $modSettings, $smcFunc, $sourcedir, $settings;

	$cat = isset($_REQUEST['category']) ? (int) $_REQUEST['category'] : -1;
	if ($cat == -1)
		fatal_error($txt['no_category'],false);

		// Get category name & layout...
      $dbresult1 = $smcFunc['db_query']('', '
         SELECT
            id_cat, name, layout
         FROM {db_prefix}categories
         WHERE id_cat = {int:cat}
         LIMIT 1',
         array('cat' => $cat)
      );
		$row1 = $smcFunc['db_fetch_assoc']($dbresult1);

		$context['category_name'] = $row1['name'];
		$context['cat_id'] = $row1['id_cat'];
		$context['cat_layout'] = $row1['layout'];
		$smcFunc['db_free_result']($dbresult1);
		// Do not allow ?category=1000 <- Basically any id value that is not an actual category.
		if (empty($context['cat_id']))
			fatal_error($txt['no_category'],false);
		// Link Tree
		$context['linktree'][] = array(

					'url' => $scripturl . '?category=' . $cat,

					'name' => $context['category_name']

				);
require_once($sourcedir . '/Subs-BoardIndex.php');
	$boardIndexOptions = array(
		'include_categories' => false,
		'ignoreThisBoard' => true,
		'base_level' => 0,
		'parent_id' => 0,
		'set_latest_post' => true,
		'countChildPosts' => !empty($modSettings['countChildPosts']),
		'cat_parent' => $context['cat_id'],
	);
	$context['category_boards'] = getBoardIndex($boardIndexOptions);
	$context['jump_to'] = array(
		'label' => addslashes(un_htmlspecialchars($txt['jump_to'])),
		'category_name' => htmlspecialchars(strtr($context['category_name'], array('&amp;' => '&'))),
	);	
	
	$context['page_title'] = $context['category_name'];
	$context['sub_template']  = 'categoryview';

}
function SetLayout() 
{
	global $context, $txt, $smcFunc;

if ($context['user']['is_admin']) {
	if (isset($_REQUEST['category']))
		$cat = (int) $_REQUEST['category'];
	else
		fatal_error($txt['no_category'],false);

	$layout = (int) $_REQUEST['layout'];
	
	// Update the category
	$smcFunc['db_query']('','
		UPDATE {db_prefix}categories
		SET layout = {int:layout}
		WHERE id_cat = {int:cat}
		LIMIT 1',
		array('cat' => $cat, 'layout' => $layout)
		);
	// Let's take them right back to the category page so they can see the change
		redirectexit('category=' . $cat);
} else
	fatal_error($txt['catview_layout_notallowed'],false);
}
?>